$(function(){
	var allLetters = [];
	var allLettersString;
	
	function getLetters(sel) {
		var letters = $(sel).val().toUpperCase().split('');
		
		return $.grep(letters, function(l) {return l.match(/[A-ZÅÄÖ]/)});
	}
	
	function updateHash() {
		location.hash =
			encodeURIComponent($('#input-letters').val())
			+ "="
			+ encodeURIComponent($('#found-words').val())
		;
	}
	
	function renderLetterboard() {
		var $letterboard = $('#letterboard');
		$letterboard.html('').hide();
		
		updateHash();

		// letters needed by the found words
		var neededLetterCounts = {};
		$.each(getLetters('#found-words'), function(n, l) {
			if(neededLetterCounts[l]) {
				neededLetterCounts[l]++;
			} else {
				neededLetterCounts[l] = 1;
			}
		});

		// availLetters: remaining letters
		var availLetters = [];
		$.each(allLetters, function(n, l) {
			if(neededLetterCounts[l]) {
				neededLetterCounts[l]--;
			} else {
				availLetters.push(l);
			}
		});
		
		// needed in found words, but not found
		var errorLetters = [];
		$.each(neededLetterCounts, function(l, lCount) {
			for(var i=1; i<=lCount; i++) {
				errorLetters.push(l);
			}
		});
		
		
		$.each(availLetters, function(n, l) {
			$('<div><span>'+l+'</span></div>').appendTo($letterboard);
		});
		$.each(errorLetters, function(n, l) {
			$('<div><span>'+l+'</span></div>').attr('className','error').appendTo($letterboard);
		});
		
		$letterboard.show();
		
	}

	function shuffle(o){
		for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
		return o;
	}
	
	var letterChange = function(forceShuffle) {
		allLetters = getLetters('#input-letters');
		
		// re-shuffle (and re-render) only if the text has actually changed
		if(forceShuffle || allLettersString !== allLetters.join('')) {
			allLettersString = allLetters.join('');
			allLetters = shuffle(allLetters);
			renderLetterboard();
		}
		
	};
	
	
	// init
	
	var input = location.hash.match(/^#(.*?)=(.*)/);
	if(input) {
		$('#input-letters').val(decodeURIComponent(input[1]));
		$('#found-words').val(decodeURIComponent(input[2]));
	}
	
	$('#input-letters')
	.change(letterChange)
	.keyup(letterChange)
	;
	
	letterChange();
	
	$('#found-words')
	.change(renderLetterboard)
	.keyup(renderLetterboard)
	;
	
	// catch enter
	$('#found-words').keypress(function(e) {
		if(e.keyCode == 13) {
			letterChange(true);
		}

	});
});
